;==========================================================
; Project    : Complete Protection System (CPS)
; Script     : CPS Alias File. (Documented)
;==========================================================
; Author     : amit (uber @ dalnet #mumbai)
; Email      : amit9815@yahoo.com
; Version    : 7.0
; FileName   : cpsalias.mrc
; Section(s) : 7
; Copyright (C) 2006 Amit (amit9815@yahoo.com)
;==========================================================

;===============
; Alias & Popups

;===============

;----------------------------------------
; Section A
;----------------------------------------
; Desc: Alias dealing with protections
;       that include the feature of 
;       kicking a nick.
;----------------------------------------
;DLL
alias mdx var %dll = $shortfn($scriptdirmdx.dll) | return $dll(%dll,$1,$2-)  
alias mdx.start mdx SetMircVersion $version | mdx MarkDialog $dname
;
; Kick Counter [kickc #Channel Nick Reason]
; Increments a variable called %kicks and displays it with the help $ord
; Also adds a variable called %kicktype. Carries values [Auto], [F9'd] or [Manual]
alias kickc {
  ;If %kicks in not already setup it will auto initalize it
  inc %kicks 1
  ;these vars will add the kicktype and the extra info of every kick
  var %i = %kicktype
  var %a = %_cpsextra
  ;we quickly unset the orignal variables
  unset %kicktype
  unset %_cpsextra
  ;finally we kick.. $ord will add nd to 2nd and th to 4th ... see /help $ord
  $iif(%a,kick $+($1-,$chr(160),,%a,,$chr(160),$ord(%kicks) kick,$chr(160),%i,$chr(160),Kref->,$chr(160),%kicks,$left($1,2)),kick $+($1-,$chr(2),$chr(160),$ord(%kicks) kick,$chr(160),%i,$chr(160),Kref->,$chr(160),%kicks,$left($1,2)))
  ; Making a record of the kick
  write $+(",$scriptdirkicks.txt,") $+([,%kicks,$left($1,2),]) -> $2 was kicked from $1 with reason $3- $+([,$fulldate,]) $iif($address($2,5),$+([,$address($2,5),]))
}

; Internal command for kick [thrash #Channel Nick Reason]
; Channel should be in protected channels list.
; The reason should be the pre described ones.
alias thrash {
  ; checking if nick is not own nick, we are op in the channel and the nick is not a nick of popular services.
  IF (($me isop $1) && ($2 != $me) && ($isservice($2) != $true) && ($isprot($1,$2) == $false)) {
    ; If voiced kick is off and nick is voiced return, vice versa
    ; $cps.rvi($1,kickvos) tells if kicking of voiced ppl is on for $1 channel
    IF ($2 isvo $1) { IF ($cps.rvi($1,kickvos) != on) { return } }
    ; If ops kick is off and nick is oped return, vice versa
    ; $cps.rvi($1,kickops) tells if kicking of oped ppl is on for $1 channel
    IF ($2 isop $1) { IF ($cps.rvi($1,kickops) != on) { return } }
    ; starting to set temp variables to be used inside this alias
    ; Kick message
    var %kickmsg = $cps.rvi($1,$3 $+ .KMSG) 
    ; Ban time
    var %_bantime = -u $+ $cps.rvi($1,$+($3,.KTIME))
    ; Ban type 
    var %bantype = $left($cps.rvi($1,$3 $+ .KTYPE),1)
    ; This variable is carried forward to f9 alias used to add ban time in kick message
    set %bantime $chr(40) $+ BT: $duration($cps.rvi($1,$+($3,.KTIME))) $+ $chr(41)
    ; If you have setup a channel URL this is where we setup it
    IF ($cps.rvi($1,CHANNELURL) != $null) { set %channelurl $cps.rvi($1,CHANNELURL) } 
    ; Unset is necessary so that we don't carry forward the previous url
    ELSE { unset %channelurl }
    ; If the punishment is kick and the trigger is auto.
    IF (($cps.rvi($1,$+($3,.KACT)) == KICK) && ($cps.rvi($1,$+($3,.KTRIG)) == AUTO)) {
      ; This one is for the kick counter. tells the kick was auto
      set %kicktype [Auto] 
      ; New feature for repeat setting +m for 60 sec
      IF (($3 == REPEAT) || ($3 == txtflood)) { IF ((m !isincs $chan($1).mode) && (%rep.save [ $+ [ $1 ] ] != NO)) { .mode $1 +m-k ChannelModeratedFor60sec | .timerMODE $+ $1 $+ $2 1 60 .mode $1 -m | set -u60 %rep.save [ $+ [ $1 ] ] NO } }
      ; The kick
      kickc $1 $2 %kickmsg %channelurl 
      ; Echo that we kicked some one
      if ($active != $1) { echo $color(info2) $_place $_time *** 4(CPS) $2 Got kicked out from $1 for $cps.rvi(CPSK,$3) $+ ! }
      ; If we have banned someone for being a possible drone bot we can send him/her a notice with a key to get UN banned
      IF ($3 == DRONE) { cps.drone $1 $2 $address($2,%bantype) }
    }
    ; If the punishment is kick-ban and the trigger is auto.
    IF (($cps.rvi($1,$+($3,.KACT)) == KICKBAN) && ($cps.rvi($1,$+($3,.KTRIG)) == AUTO)) {
      set %kicktype [Auto]
      ; New feature for repeat setting +m for 60 sec
      IF (($3 == REPEAT) || ($3 == txtflood)) { IF ((m !isincs $chan($1).mode) && (%rep.save [ $+ [ $1 ] ] != NO)) { .mode $1 +m-k ChannelModeratedFor60sec | .timerMODE $+ $1 $+ $2 1 60 .mode $1 -m | set -u60 %rep.save [ $+ [ $1 ] ] NO } }
      ; This time we are adding ban too
      if ($3 != JPFLOOD) { ban %_bantime $1 $2 %bantype }
      kickc $1 $2 %kickmsg %bantime %channelurl
      ; This echo says we kicked-banned
      if ($active != $1) { echo $color(info2) $_place $_time *** 4(CPS) $2 Got kicked out from $1 for $cps.rvi(CPSK,$3) $+ ! }
      IF ($3 == DRONE) { cps.drone $1 $2 $address($2,%bantype) }
    }
    ; If the punishment is kick and the trigger is manual.
    IF (($cps.rvi($1,$+($3,.KACT)) == KICK) && ($cps.rvi($1,$+($3,.KTRIG)) == MANUAL)) {
      ; We echo that some one broke a rule
      echo $color(info2) $_place $_time *** 4(CPS) Warning possible rule breakage in $1 by $2 defined as $cps.rvi(CPSK,$3) hit F9 to kick or DOUBLE-CLICK here.
      ; Variables necessary fro F9 alias 
      ; We won't send the ban time or type here this will make manual kicker think that we only need to kick the nick
      set %mn.kick.chan $1
      set %mn.kick.nick $2
      set %mn.kick.message %kickmsg
      set %mn.kick.mods $3
      ; This deactivates once we have hit f9. This is good incase you hit f9 multiple times
      set %mn.activate ON
      IF ($3 == DRONE) { set $+(%,mn.drone.,$2) $1 }
    }
    ; If the punishment is kick-ban and the trigger is manual.
    IF (($cps.rvi($1,$+($3,.KACT)) == KICKBAN) && ($cps.rvi($1,$+($3,.KTRIG)) == MANUAL)) {
      echo $color(info2) $_place $_time *** 4(CPS) Warning possible rule breakage in $1 by $2 defined as $cps.rvi(CPSK,$3) hit F9 to kick or DOUBLE-CLICK here.
      ; Clean up previous variables
      unset %mn.*
      set %mn.kick.chan $1
      set %mn.kick.nick $2
      set %mn.kick.message %kickmsg
      ;this time we send ban time and ban type
      set %mn.ban.time %_bantime
      set %mn.ban.type %bantype
      set %mn.kick.mods $3
      set %mn.activate ON
      IF ($3 == DRONE) { set $+(%,mn.drone.,$2) $1 }
    }
    ; Play the sound file if sound trigger is on
    ; Note it is always good to check if file exists so we do a $isfile
    IF (%_cps.wav == on) { $iif($isfile($scriptdirruleb.wav),splay -qw $scriptdirruleb.wav) }
  }
}

; Function Key or F9 [F9]
; Parameters are sent internally.
; Upon hitting it ones it self disables, will only work when enabled again internally
alias F9 {
  ; Checking if alias is activated
  IF (%mn.activate == ON) {
    ; Need to check if you are _STILL_ op in the channel
    IF ($me isop %mn.kick.chan) {
      set %kicktype [F9'd]
      ; New feature for repeat setting +m for 60 sec
      IF ((%mn.kick.mods == repeat) || (%mn.kick.mods == txtflood)) { IF ((m !isincs $chan(%mn.kick.chan).mode) && (%rep.save [ $+ [ %mn.kick.chan ] ] != NO)) { .mode %mn.kick.chan +m-k ChannelModeratedFor60sec | .timerMODE $+ %mn.kick.chan $+ %mn.kick.nick 1 60 .mode %mn.kick.chan -m | set -u60 %rep.save [ $+ [ %mn.kick.chan ] ] NO } }
      ; If ban time was not included in sent parameters the the punishment was a kick
      IF (%mn.ban.time == $null) {
        kickc %mn.kick.chan %mn.kick.nick %mn.kick.message %channelurl 
        unset %mn.* 
        unset %channelurl
      }
      ; if ban time is not null then the punishment is a kick ban
      IF (%mn.ban.time != $null) {
        ban %mn.ban.time %mn.kick.chan %mn.kick.nick %mn.ban.type
        kickc %mn.kick.chan %mn.kick.nick %mn.kick.message %bantime %channelurl
        ;this varible came from /thrash
        IF (%mn.drone. [ $+ [ %mn.kick.nick ] ] == %mn.kick.chan) { 
          cps.drone %mn.kick.chan %mn.kick.nick $address(%mn.kick.nick,%mn.ban.type) 
        }
        unset %mn.* 
        unset %channelurl
        unset %bantime
      }
    }
    ELSE { echo $color(info2) $_place $_time *** 4(CPS) Warning you are not op in %mn.chan.kick }
  }
}

;----------------------------------------
; Section B
;----------------------------------------
; Desc: Alias dealing with protections
;       that _DON'T_ include the 
;       feature of kicking a nick.
;----------------------------------------


; Banning nicks after they quit [Banned #channel Nick Reason Address]
; This alias requires the address parameter to be sent via the calling remote.
; The channel should be in protected list. The reasons should be one of predefined ones.
alias banned {
  ; Checking if nick is not own nick, we are op in the channel and the nick was not a popular service nick
  IF (($me isop $1) && ($2 != $me) && ($isservice($2) != $true) && ($isprot($1,$2) == $false)) {
    ; If voiced kick is off and nick is voiced return, vice versa
    IF ($2 isvo $1) { IF ($cps.rvi($1,KICKVOS) != ON) { return } }
    ; If ops kick is off and nick is oped return, vice versa
    IF ($2 isop $1) { IF ($cps.rvi($1,KICKOPS) != ON) { return } }
    ; Setting required variables
    var %_bantime = $+(-u,$cps.rvi($1,$3 $+ .KTIME)) 
    var %_bantype = $left($cps.rvi($1,$3 $+ .KTYPE),1) 
    var %_add = $4
    var %_display.time = (BT: $replace([ $+ [ %bantime ] ],-u,$chr(32)) $+ ) sec
    IF ((%_add != $null) && (%_bantime != $null)) {
      ; If the punishment ban is auto
      IF ($cps.rvi($1,$+($3,.KTRIG)) == AUTO) {
        ban %_bantime $1 %_add
        echo $color(info2) $_place $_time *** 4(CPS) $2 is banned from $1 for $replace($3,kline,k-line quit,excess,excess Flood quit,squit,spam quit) [Bantime $cps.rvi($1,$+($3,.KTIME)) second(s)]
      }
      ; If the punishment ban is manual
      IF ($cps.rvi($1,$+($3,.KTRIG)) == MANUAL) {
        echo $color(info2) $_place $_time *** 4(CPS) Warning! possible rule breakage by $2 in $1 defined as $replace($3,kline,kline quit,excess,excess Flood quit,squit,spam quit) hit SHIFT + F9 to ban or DOUBLE-CLICK here!
        unset %bn.*
        set %bn.chan.ban $1
        set %bn.nick.ban $4
        set %bn.btime %_bantime
        ; Shift - f9 activator
        set %bn.activate ON
      }
    }
  }
  ELSE { echo $color(info) $_place $_time Error banned [ $+ $1- $+ ] }
  ; Sound filer player
  IF (%_cps.wav == on) { $iif($isfile($scriptdirruleb.wav),splay -qw $scriptdirruleb.wav) }
}

; SHIFT + F9 or SF9 [SF9]
; Internal command activates your F9 key, You should be pressing SHIFT before hitting F9
; Similar life cycle as F9
alias SF9 {
  IF (%bn.activate == ON) {
    IF ($me isop %bn.chan.ban) {
      ban %bn.btime %bn.chan.ban %bn.nick.ban 
      unset %bn.*
    }
    ELSE { echo $color(info2) $_place $_time *** 4(CPS) Warning you are not op in %bn.chan.ban }
  }
}

;----------------------------------------
; Section C
;----------------------------------------
; Desc: Contains the windows menus or the
;       right click popups.
;----------------------------------------

menu @sb,@cps {
  $iif($active == @sb && $sock(sb),Perform a command) : { sb_out $$input(Enter a server command which you want the bot to perform. E.g "Privmsg $me :hello there" or "Part #Channel",e,Socket Bot Control) } 
  $iif($active == @sb && !$sock(sb),Force Connect) : { sb_open }
  $iif($active == @sb,-)
  Logging
  .$iif(!$window($active).logfile,Enable,$style(1) Enable): { log on $active }
  .$iif($window($active).logfile,Disable,$style(1) Disnable): { log off $active }  
  Clear: { Clear $active }
  Close: { window -c $active }
  -
}


; Window Spam Help
; Defines if you double click it closes the window
menu @mspam {
  dclick: { _mspam.help }
}

; Window Auto Greet Help
; Defines if you double click it closes the window
menu @agreet.help {
  dclick: { window -c $active }
}

; Window Ignore Help
; Defines if you double click it closes the window
menu @ignore.help {
  dclick: { window -c $active }
}

; Window Mode Help
; Defines if you double click it closes the window
menu @mode.help {
  dclick: { window -c $active }
}

; Window Spam Help
; Displays the _close_ popup in the window when u right click it.
menu @mspam {
  Close: { _mspam.help }
}

; Window Auto Greet Help
; Displays the _close_ popup in the window when u right click it.
menu @agreet.help {
  Close: { window -c $active }
}

; Window Ignore Help
; Displays the _close_ popup in the window when u right click it.
menu @ignore.help {
  Close: { window -c $active }
}

; Window Mode Help
; Displays the _close_ popup in the window when u right click it.
menu @mode.help {
  Close: { window -c $active }
}

; Kick/Warn/Ban popups these are dynamic and will only show if are oped in the channel
; To display right click on any nick in nick list of a channel.
menu nicklist {
  $iif($me isop $active,Warnings/Bans/Kicks)
  .Warnings
  ..Advertising: { describe $active Explains to $1 that advertising web-sites or other irc servers in private or channel screen is not acceptable on $network $+ , if you don't stop you are risking a kick/ban. }
  ..Inviting: { describe $active explains to $1 that inviting chatters from one channel to another channel is not allowed on $network $+ , you would be kicked-banned or your ip k-lined. }
  ..Annoyance: { describe $active explains to $1 that annoying or bugging other chatters and lameness is not tolerated in $chan you would be kicked banned if you continue with it. }
  ..Swearing: { describe $active explains to $1 that using bad or unacceptable words is not allowed in $chan you would be kicked-banned if you continue. }
  ..Flooding: { describe $active explains to $1 that flooding(too much text/actions/notices/ctcps) is not allowed in $chan IF you continue you will be kicked and banned form $chan $+ . }
  ..Repeating: { describe $active explains to $1 that we can hear you once you don't have to repeat in the channel main screen. }
  ..Caps: { describe $active explains to $1 that using of CAPS is considered shouting in $network which is a rule breakage. This could result in a kick-ban. }
  ..Auto Greets: { describe $active explains to $1 that you are sending Auto-Greet messages. Type /!remote off and join #NOHack for more help. }
  ..Offensive Nick: { describe $active explains to $1 that your nick has an unacceptable word in it; change it or risk being kicked out. }
  ..Offensive Ident: { describe $active explains to $1 that your ident has an unacceptable word in it; change it or risk being kicked out. }
  ..Hassling ops: { describe $active explains to $1 that Hassling ops for private reasons or any other stuff will not be tolerated in $chan $+ . }
  ..Sex Channel: { describe $active explains to $1 that $chan is not a sex channel or a pick up joint. Avoid sexual suggestions or risk a kick/ban. }
  ..Family Channel: { describe $active explains to $1 that $chan is a family oriented channel; avoid rude language towards other chatters and behave. }
  ..English Only: { describe $active explains to $1 that $chan is an English only channel; don't speak furbish here! }
  ..Op Begging: { describe $active explains to $1 nowadays becoming ops is pretty tough. first, u got to kiss the big-toe of all current ops, then u got to pay the 1,00,000 dollars per-op registration fee, and then all u get to do as op is kick/ban and help lame people, it just isnt worth it. }
  ..Script: { describe $active explains to $1 your script is banned by $network Authorities as it spams and has backdoors in it. Reinstall a fresh mIRC or get a clean script. }
  .Bans
  ..1 min
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u60 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u60 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u60 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u60 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u60 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u60 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u60 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u60 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u60 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u60 $active $1 9 }
  ..3 Mins
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u180 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u180 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u180 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u180 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u180 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u180 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u180 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u180 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u180 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u180 $active $1 9 }
  ..5 Mins
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u300 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u300 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u300 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u300 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u300 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u300 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u300 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u300 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u300 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u300 $active $1 9 }
  ..10 Mins
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u600 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u600 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u600 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u600 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u600 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u600 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u600 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u600 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u600 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u600 $active $1 9 }
  ..30 Mins
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u1800 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u1800 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u1800 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u1800 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u1800 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u1800 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u1800 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u1800 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u1800 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u1800 $active $1 9 }
  ..1 Hour
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u1800 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u1800 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u1800 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u1800 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u1800 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u1800 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u1800 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u1800 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u1800 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u1800 $active $1 9 }
  ..12 Hours
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u43200 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u43200 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u43200 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u43200 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u43200 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u43200 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u43200 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u43200 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u43200 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u43200 $active $1 9 }
  ..1 Day
  ...Ban Types For $snicks
  ...-
  ...Type 0 -> $address($1,0) : { .ban -u86400 $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban -u86400 $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban -u86400 $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban -u86400 $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban -u86400 $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban -u86400 $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban -u86400 $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban -u86400 $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban -u86400 $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban -u86400 $active $1 9 }
  ..Permanent
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : { .ban $active $1 0 }
  ...Type 1 -> $address($1,1) : { .ban $active $1 1 }
  ...Type 2 -> $address($1,2) : { .ban $active $1 2 }
  ...Type 3 -> $address($1,3) : { .ban $active $1 3 }
  ...Type 4 -> $address($1,4) : { .ban $active $1 4 }
  ...Type 5 -> $address($1,5) : { .ban $active $1 5 }
  ...Type 6 -> $address($1,6) : { .ban $active $1 6 }
  ...Type 7 -> $address($1,7) : { .ban $active $1 7 }
  ...Type 8 -> $address($1,8) : { .ban $active $1 8 }
  ...Type 9 -> $address($1,9) : { .ban $active $1 9 }
  ..Custom (?) 
  ...Ban Types For $snicks 
  ...-
  ...Type 0 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 0
  }
  ...Type 1 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 1
  }
  ...Type 2 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 2
  }
  ...Type 3 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 3
  }
  ...Type 4 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 4
  }
  ...Type 5 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 5
  }
  ...Type 6 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 6
  }
  ...Type 7 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 7
  }
  ...Type 8 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 8
  }
  ...Type 9 -> $address($1,0) : {
    var %custome.ban.time = $calc($$input(Enter Ban Time In Minutes,e) * 60)
    .ban -u $+ %custome.ban.time $active $1 9
  }
  .Kicks
  ..Kick $$1 (Why?):{
    set %kicktype [Manual]
    kickc # $$1 $$?="reason to kick:" 
  }
  ..Advertising: { _mkick $1 ad $chan }
  ..Inviting: { _mkick $1 invi $chan }
  ..Annoyance: { _mkick $1 annoy $chan }
  ..Swearing: { _mkick $1 swear $chan }
  ..Flooding: { _mkick $1 Flood $chan }
  ..Repeating: { _mkick $1 rep $chan }
  ..CAPS: { _mkick $1 caps $chan }
  ..Auto Greets: { _mkick $1 autog $chan }
  ..Offensive Nick: { _mkick $1 nick $chan }
  ..Offensive Ident: { _mkick $1 ident $chan }
  ..Hassling Ops: { _mkick $1 hass $chan }
  ..Sexual Suggestions: { _mkick $1 sex $chan }
  ..Family Channel: { _mkick $1 fmli $chan }
  ..English Only: { _mkick $1 english $chan }
  ..Op Begging: { _mkick $1 opbeg $chan }
  ..Script: { _mkick $1 script $chan }
}

;Window: Spam Detector Help
;if the windo is open and the same alias is called again the window will close
alias _mspam.help {
  IF ($window(@mspam) == @mspam) { window -c @mspam }
  ELSE {
    window -ado +l @mspam 1000 30 310 320 "Arial" 11
    titlebar @mspam %_cpslogo Spam Detector Help
    aline @mspam -=[ 4 $+ %_cpslogo Spam Detector ]=-
    aline @mspam This section of 4(CPS) thrives to protect users
    aline @mspam from spammers that spam in private and keep
    aline @mspam on annoying you. Although +R mode helps but
    aline @mspam still some networks don't support +R and
    aline @mspam many people deliberately spam and they have
    aline @mspam registered nicks.
    aline @mspam $+(,$color(back),$chr(44),$color(back)) ... 10Features in (CPS) Spam Detector
    aline @mspam 4a] You can add as many words as you like in
    aline @mspam the spam words list. You can use wildcards like *?
    aline @mspam this makes the search of words easy.
    aline @mspam 4b] You can set to message the nick who spammed
    aline @mspam you that his message has been ignored.
    aline @mspam 4c] You may opt to auto ignore that nick's ip
    aline @mspam so as to prevent further spam.
    aline @mspam 4d] You can opt to kick ban the nick from the
    aline @mspam channels you are oped in.
    aline @mspam 7NOTE:- IF you opt to ignore the nick the query message
    aline @mspam is closed automatically.
  }
}

;setup display menu
menu status,channel,menubar,@cps,@sb {
  Complete Protection System
  .Setup: { cps }
  .Private Protection System: { pps }
  .Warning Options: { cps.warn }
  .Warnings Editor: { _warnedit }
  .Private Spam Detector: { _cps.spam }
  .SpamCheck Bot: { sb_dialog }
  .$iif($active ischan,-)
  .$iif($active ischan,Clone Controler): { ccontrol }
  .$iif($active ischan,Scan Ip): {
    IF ($$input(Input an Ip To Search Possible Matches in $active $+ . You Can use wildcards like ? * for a more extensive search.,e,Ip Scanner)) {
      var %a = $ifmatch
      echo $color(info2) -a $_time *** 4(CPS) Ip Scanner Scanning in progress...
      IF ($ialchan(%a,$active,0) > 0) {
        echo $color(info2) -a $_time *** 4(CPS) Found Following User(s) matching %a Ip.
        var %b = $ialchan(%a,$active,0)
        var %a.num = 1 
        while (%b) {
          echo $color(info2) -a $_time *** 4(CPS) %a.num $+ )  Nick -> $+([,$ialchan(%a,$active,%b).nick,]) Full address -> $+([,$address($ialchan(%a,$active,%b).nick,5),])
          dec %b 1
          inc %a.num 1
        }
        echo $color(info2) -a $_time *** 4(CPS) End Of Scan found -> $calc(%a.num - 1) user(s) matching %a  
      }

      ELSE { echo $color(info2) -a $_time *** 4(CPS) End Of Scan found -> 0 user(s) matching %a  }
    }
  }
  .-
  .About: { _about }
  .-
  .$iif(status* iswm $active,-)
  .$iif(status* iswm $active,Reload): { load -rs1 $scriptdirfirststep.mrc }
  .$iif(status* iswm $active,Uninstall): { IF ($input(Are you sure you want to uninstall cps,8,Un installation Wizard) == $true) { _unload all } }
}

; Window: Auto Greet Help
; If the window is open and the same alias is called again the window will close
alias _help.agreet {
  IF ($window(@agreet.help) == @agreet.help) { window -c @agreet.help }
  ELSE {
    window -ado +l @agreet.help 1000 100 300 260 "Arial" 11
    titlebar @agreet.help %_cpslogo Auto Greet Help
    aline @agreet.help 4(CPS) Now has an auto Greet System in it.
    aline @agreet.help You can set a *Channel Specific* Auto Greet
    aline @agreet.help message with it. Whenever a nick joins that
    aline @agreet.help channel he will receive that message via notice.
    aline @agreet.help 4
    aline @agreet.help 3Note: 
    aline @agreet.help a) You can enter a message which is less or
    aline @agreet.help equal to 300 alphabets.
    aline @agreet.help b) If you want to include the nick name in message
    aline @agreet.help use !nick! This will be auto replaced by the nick
    aline @agreet.help when the message is sent. Similarly if you want to 
    aline @agreet.help say channel name use !chan!. 
    aline @agreet.help c) Don't enter variables (%var) or an
    aline @agreet.help identifier ($identifier) in the message that will
    aline @agreet.help cause an error.
  }
}

; Window: Set Mode Help
; If the window is open and the same alias is called again the window will close
alias _help.mode {
  IF ($window(@mode.help) == @mode.help) { window -c @mode.help }
  ELSE {
    window -ado +l @mode.help 1000 100 300 160 arial 11
    titlebar @mode.help %_cpslogo Set Mode Help
    aline @mode.help Plenty of networks on iRC have now started
    aline @mode.help protection mode for users generally its R
    aline @mode.help if the network you are on supports R mode
    aline @mode.help you can put R in the edit box else you can
    aline @mode.help put a  -  in it. If your network has some
    aline @mode.help other mode similar too R you can even enter
    aline @mode.help that here.
    aline @mode.help NOTE:- Don't leave this field blank!!!
  }
}

; Window: Ignore Help
; If the window is open and the same alias is called again the window will close
alias _help.ignore {
  IF ($window(@ignore.help) == @ignore.help) { window -c @ignore.help }
  ELSE {
    window -ado +l @ignore.help 1000 100 300 160 arial 11
    titlebar @ignore.help %_cpslogo Set Ignore Help
    aline @ignore.help CPS can be configured to ignore people who
    aline @ignore.help flood you. It now "SUPPORTS" /silence
    aline @ignore.help command. It will use mIRC's /ignore and 
    aline @ignore.help /silence so just enter the number of 
    aline @ignore.help seconds for which you want to ignore the nick.
    aline @ignore.help If you don't want to ignore the nick enter 0
    aline @ignore.help in the edit box. CPS will not ignore known
    aline @ignore.help service bots.
    aline @ignore.help NOTE:- Don't leave this field blank!!!
  }
}

;----------------------------------------
; Section D
;----------------------------------------
; Desc: Contains Aliases used by various 
;       CPS dialogs.
;----------------------------------------


; Cps.dialog.set[XX]
; Below 36 alias are used by main setup dialog to call the sub settings dialog
; %_cps.par is a parse value which tells the dialog which settings to display
; Each parse value is unique so don't edit them
alias cps.dialog.set1 {
  set %_cps.par 1
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set2 {
  set %_cps.par 9
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set3 {
  set %_cps.par 10
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set4 {
  set %_cps.par 19
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set5 {
  set %_cps.par 20
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set6 {
  set %_cps.par 21
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set7 {
  set %_cps.par 22
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set8 {
  set %_cps.par 25
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set9 {
  set %_cps.par 2
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set10 {
  set %_cps.par 3
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)

}

alias cps.dialog.set11 {
  set %_cps.par 24
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set12 {
  set %_cps.par 11
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set13 {
  set %_cps.par 12
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set14 {
  set %_cps.par 26
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set15 {
  set %_cps.par 13
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set16 {
  set %_cps.par 4
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set17 {
  set %_cps.par 5
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set18 {
  set %_cps.par 6
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set19 {
  set %_cps.par 7
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set20 {
  set %_cps.par 23
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

alias cps.dialog.set21 {
  set %_cps.par 27
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set22 {
  set %_cps.par 14
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set23 {
  set %_cps.par 15
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set24 {
  set %_cps.par 28
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set25 {
  set %_cps.par 29
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set26 {
  set %_cps.par 30
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set27 {
  set %_cps.par 31
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set28 {
  set %_cps.par 32
  $iif($dialog(cps.gen4),dialog -v cps.gen4,dialog -mdo cps.gen4 cps.gen4)
}

alias cps.dialog.set29 {
  set %_cps.par 8
  $iif($dialog(cps.gen1),dialog -v cps.gen1,dialog -mdo cps.gen1 cps.gen1)
}

alias cps.dialog.set30 {
  set %_cps.par 16
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set31 {
  set %_cps.par 17
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set32 {
  set %_cps.par 33
  $iif($dialog(cps.gen5),dialog -v cps.gen5,dialog -mdo cps.gen5 cps.gen5)
}

alias cps.dialog.set33 {
  set %_cps.par 18
  $iif($dialog(cps.gen2),dialog -v cps.gen2,dialog -mdo cps.gen2 cps.gen2)
}

alias cps.dialog.set34 {
  set %_cps.par 34
  $iif($dialog(cps.gen5),dialog -v cps.gen5,dialog -mdo cps.gen5 cps.gen5)
}

alias cps.dialog.set35 {
  set %_cps.par 35
  $iif($dialog(cps.gen5),dialog -v cps.gen5,dialog -mdo cps.gen5 cps.gen5)
}

alias cps.dialog.set36 {
  set %_cps.par 36
  $iif($dialog(cps.gen3),dialog -v cps.gen3,dialog -mdo cps.gen3 cps.gen3)
}

; Cps [cps]
; Opens the main setup dialog, if its open it puts the focus back on the dialog
alias cps { $iif($dialog(cps),dialog -voe cps,dialog -mdo cps cps) }

; Ccontrol [ccontrol]
; Opens the clone controller dialog
alias ccontrol { $iif($dialog(ccontroller),dialog -voe ccontroller,dialog -mdo ccontroller ccontroller) }

; Duplicate alias for calling setup dialog
alias _cps { cps }

; Calls the spam detector
alias _cps.spam { $iif($dialog(cps.spam),dialog -v cps.spam,dialog -mdo cps.spam cps.spam) }

; Warnings options
alias cps.warn { $iif($dialog(cps.warn) == cps.warn,dialog -v cps.warn,dialog -mdo cps.warn cps.warn) }

; About dialog
alias _about { $iif($dialog(_about),dialog -v _about,dialog -md _about _about) }

; Warnings message editor
alias _warnedit { $iif($dialog(_warnedit),dialog -v _warnedit,dialog -mdo _warnedit _warnedit) }

; Private protection system
alias pps { $iif($dialog(pps),dialog -voe pps,dialog -mdo pps pps) }

; Spam bot dialog
alias sb_dialog { $iif($dialog(sb.set),dialog -voe sb.set,dialog -mdo sb.set sb.set) }

; PPS exceptional nick list dialog
alias pps.ex { $iif($dialog(pps.ex),dialog -voe pps.ex,dialog -mdo pps.ex pps.ex) }

; Alias for setup dialog called when u clicak a checkbox
alias _cpsclicked {
  IF ($did(cps,$1).state == 1) { did -e cps $calc($1 - 100) }
  ELSE { did -b cps $calc($1 - 100) }
  IF ($did == 537) { 
    IF ($did(cps,$1).state == 0) { .did -r cps 437 }
    ELSE { .did -ra cps 437 $cps.rvi(%_cps,agreet) }
  }
}

; These alias are used for below purpose
alias uclick {
  did -u cps $1
  _cpsclicked $1
}

alias cclick {
  did -c cps $1
  _cpsclicked $1
}

; Alias for setup dialog called when u clicak a checkbox
; Enables disables 
alias _cpscheck {
  IF (%_cps != $null) {
    IF ($cps.rval(%_cps,n1,1) == 1) { cclick 501 }
    ELSE { uclick 501 }
    IF ($cps.rval(%_cps,n1,2) == 1) { cclick 502 }
    ELSE { uclick 502 }
    IF ($cps.rval(%_cps,n1,3) == 1) { cclick 503 }
    ELSE { uclick 503 }
    IF ($cps.rval(%_cps,n1,4) == 1) { cclick 504 } 
    ELSE { uclick 504 }
    IF ($cps.rval(%_cps,n1,5) == 1) { cclick 505 }    
    ELSE { uclick 505 }
    IF ($cps.rval(%_cps,n2,1) == 1) { cclick 506 }
    ELSE { uclick 506 }
    IF ($cps.rval(%_cps,n2,2) == 1) { cclick 507 }
    ELSE { uclick 507 }
    IF ($cps.rval(%_cps,n2,3) == 1) { cclick 508 }
    ELSE { uclick 508 }
    IF ($cps.rval(%_cps,n2,4) == 1) { cclick 509 }
    ELSE { uclick 509 }
    IF ($cps.rval(%_cps,n2,5) == 1) { cclick 510 }
    ELSE { uclick 510 }
    IF ($cps.rval(%_cps,n3,1) == 1) { cclick 511 }
    ELSE { uclick 511 }
    IF ($cps.rval(%_cps,n3,2) == 1) { cclick 512 }
    ELSE { uclick 512 }
    IF ($cps.rval(%_cps,n3,3) == 1) { cclick 513 }
    ELSE { uclick 513 }
    IF ($cps.rval(%_cps,n3,4) == 1) { cclick 514 } 
    ELSE { uclick 514 }
    IF ($cps.rval(%_cps,n3,5) == 1) { cclick 515 }
    ELSE { uclick 515 }
    IF ($cps.rval(%_cps,n4,1) == 1) { cclick 516 }
    ELSE { uclick 516 }
    IF ($cps.rval(%_cps,n4,2) == 1) { cclick 517 }
    ELSE { uclick 517 }
    IF ($cps.rval(%_cps,n4,3) == 1) { cclick 518 }
    ELSE { uclick 518 }
    IF ($cps.rval(%_cps,n4,4) == 1) { cclick 519 }
    ELSE { uclick 519 }
    IF ($cps.rval(%_cps,n4,5) == 1) { cclick 520 }
    ELSE { uclick 520 }
    IF ($cps.rval(%_cps,n5,1) == 1) { cclick 521 }
    ELSE { uclick 521 }
    IF ($cps.rval(%_cps,n5,2) == 1) { cclick 522 }
    ELSE { uclick 522 }
    IF ($cps.rval(%_cps,n5,3) == 1) { cclick 523 }
    ELSE { uclick 523 }
    IF ($cps.rval(%_cps,n5,4) == 1) { cclick 524 }
    ELSE { uclick 524 }
    IF ($cps.rval(%_cps,n5,5) == 1) { cclick 525 }
    ELSE { uclick 525 }
    IF ($cps.rval(%_cps,n6,1) == 1) { cclick 526 }
    ELSE { uclick 526 }
    IF ($cps.rval(%_cps,n6,2) == 1) { cclick 527 }
    ELSE { uclick 527 }
    IF ($cps.rval(%_cps,n6,3) == 1) { cclick 528 }
    ELSE { uclick 528 }
    IF ($cps.rval(%_cps,n6,4) == 1) { cclick 529 }
    ELSE { uclick 529 }
    IF ($cps.rval(%_cps,n6,5) == 1) { cclick 530 }
    ELSE { uclick 530 }
    IF ($cps.rval(%_cps,n7,1) == 1) { cclick 531 }
    ELSE { uclick 531 }
    IF ($cps.rval(%_cps,n7,2) == 1) { cclick 532 }
    ELSE { uclick 532 }
    IF ($cps.rval(%_cps,n7,3) == 1) { cclick 533 }
    ELSE { uclick 533 }
    IF ($cps.rval(%_cps,n7,4) == 1) { cclick 534 }
    ELSE { uclick 534 }
    IF ($cps.rval(%_cps,n7,5) == 1) { cclick 535 }
    ELSE { uclick 535 }
    IF ($cps.rval(%_cps,n8,1) == 1) { cclick 536 }
    ELSE { uclick 536 }
    IF ($cps.rval(%_cps,n8,2) == 1) {
      did -c cps 537
      .did -ra cps 437 $cps.rvi(%_cps,agreet)
      _cpsclicked 537
    }
    ELSE {
      did -u cps 537
      .did -r cps 437
      _cpsclicked 537
    }
    IF ($cps.rvi(%_cps,limiter) == on) { did -c cps 7 }
    IF ($cps.rvi(%_cps,userlimit) != $null) { did -ra cps 8 $cps.rvi(%_cps,userlimit) }
    IF ($cps.rvi(%_cps,userlimit.time) != $null) { did -ra cps 10 $cps.rvi(%_cps,userlimit.time) }
    IF ($cps.rvi(%_cps,kickops) == on) { did -c cps 33 }
    ELSE { did -u cps 33 }
    IF ($cps.rvi(%_cps,kickvos) == on) { did -c cps 34 }
    ELSE { did -u cps 34 }
  }
}

; Reset warnings [reset dialog-name ID type]
; This is an internal alias to reset the warning messages to the default ones.
; Dialog _warnedit must be open.
alias reset {
  IF ($3 == swear) {
    var %ac = Swearing using bad or unacceptable words is not allowed in this channel mind your language!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == repeat) {
    var %ac = Repeating your self uselessly won't get you anywhere stop repeating here!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == text) {
    var %ac = Don't Flood this channel by typing lines too fast try to write more words in a line and just slow down a little bit thanks!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == long) {
    var %ac = You are breaking channel rules by typing too much words in one line, this is considered Flood stop it!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == punctuation) {
    var %ac = Don't use too many ?'s and !'s in this channel this is considered a rule breakage!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == caps) {
    var %ac = Don't use too many upper cased letters in channel main screen it is considered shouting and rule breakage!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == colors) {
    var %ac = Don't use too many ctrl codes in your text it is taken as a Flood attempt in channels you can be kicked for it!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == urlads) {
    var %ac = Don't advertise those un allowed urls in this channel you can be kicked banned for it!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == chanads) {
    var %ac = Don't advertise other channels in this channel it is considered as mass spamming and you might be kicked banned for it!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == non) {
    var %ac = Warning this is an English only channel you are speaking in non letters which is considered rule breakage; refer that to in future to avoid a kick ban!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == sounds) {
    var %ac = This is a warning; don't play mp3's in channel main screen it is strickly against channel rules!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == slaps) {
    var %ac = Slapping people or using other such pops on channel mains is not allowed here - stop now or risk being kicked banned!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac

  }
  IF ($3 == user) {
    var %ac = Leave the newbies alone - don't exploit them with lame exploits you will be kicked banned for it!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == cnote) {
    var %ac = Don't send channel notices this right is a privilege of channel ops!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == away) {
    var %ac = Don't spam the channel by using away scripts here that send spam notices or advertises that you are away!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == clone) {
    var %ac = You have a possible clone or a ghost In the channel! Use /nickserv ghost nick password to kill the ghost or remove your clone ELSE you will be kicked!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
  IF ($3 == noneng) {
    var %ac = This is an English only channel; Don't speak Arabic or use ASCII characters here!
    did -ra $1 $2 %ac
    set %_cps. [ $+ [ $3 ] ] $+ .warn %ac
  }
}

; Drop down menu fill alias [dobans Name-Of-Substtings_dialog]
; Used to fill up the choose ban type option of sub settings dialog.
; This alias cannot be used with other dialogs unless or until it has a drop down menu with the id 201
alias dobans {
  did -r $1 201
  did -a $1 201 1: *!*uid@host.domain 
  did -a $1 201 2: *!*@host.domain 
  did -a $1 201 3: *!*uid@*.domain 
  did -a $1 201 4: *!*@*.domain 
  did -a $1 201 5: nick!uid@host.domain 
  did -a $1 201 6: nick!*uid@host.domain 
  did -a $1 201 7: nick!*@host.domain 
  did -a $1 201 8: nick!*uid@*.domain 
  did -a $1 201 9: nick!*@*.domain
  did -a $1 201 10: *!uid@host.domain
}


; Disable checkboxes of setup dialog [_dc] 
alias _dc {
  var %i = 501

  while (%i < 538) {
    did -b cps %i
    inc %i 1 
  }
}

; Disable buttons of setup dialog [_db] 
alias _db {
  var %i = 401
  while (%i < 438) {
    did -b cps %i
    inc %i 1
  }
}

; Disable other ids of setup dialog [_do] 
alias _do { did -b cps 4,5,6,7,8,9,10,11,12,13,14,16,306,33,34 }

; Enable checkboxes of setup dialog [_ec] 
alias _ec {
  var %i = 501
  while (%i < 538) {
    did -e cps %i
    inc %i 1
  }
}

; Enable buttons of setup dialog [_eb] 
alias _eb {
  var %i = 401
  while (%i < 438) {
    did -e cps %i
    inc %i 1
  }
}

; Enable other ids of setup dialog [_eo] 
alias _eo { did -e cps 4,5,6,7,8,9,10,11,12,13,14,16,306,33,34 }

; Enable the buttons of sub settings dialog(s) [_dc] 
alias _enab { did -e cps.gen1 1,2,3,5,6,7,8,16,19,100,101,102,103,200,201,202,300,303 }

alias _enab2 { did -e cps.gen2 1,55,3,7,4,6,100,101,102,103,200,16,201,19,300,5,70,8,303,4,2,202 }

alias _enab3 { did -e cps.gen3 1,55,202,6,100,101,102,103,200,16,201,19,300,5,70 }


alias _enab4 { did -e cps.gen4 202,100,101,102,103,200,16,201,19,300,5,70,8,303 }

alias _enab5 { did -e cps.gen5 100,101,200,16,201,300,70,8,303,4 }

; Rescan [dialog name]
; Scans active window for clones
; Used in clone control dialog
alias rescan {
  IF ($active !ischan) {
    echo $color(info2) $_place $_time *** 4(CPS) You can use (Clone Control) dialog in a channel only!
    dialog -x $dname
    halt
  }
  Else {
    did -r $1 1
    var %tnicks = $nick($active,0)
    :scan
    var %tadds = $address($nick($active,%tnicks),$left($did($1,201),1))
    IF ($ialchan(%tadds,$active,0) > 1) {
      did -a $1 1 %tadds <> $nick($active,%tnicks)
      var %xdid = yes
    }
    IF (%tnicks != 0) {
      dec %tnicks
      goto scan
    }
    $iif(%xdid != yes,did -a $1 1 No Clones Found In $active Matching That Address Type) 
  }
}


;----------------------------------------
; Section E
;----------------------------------------
; Desc: Contains Misc Alias used all over
;       the CPS files.
;----------------------------------------


; Aircdll path [$airc]
; Custom identifier that returns the path of aircdll.dll
alias airc { return $scriptdiraircdll.dll }

; Caps lock detector [CAPS #Channel #nick TEXT]
; This alias detects if a nick is using too much caps and then punishes him or her accordingly
; The text or the last parameter is stripped of colors before it is sent to alias.
alias caps {
  ; If a has said a small line in caps... less then 30 letters and 8 words the cps check ignores as this is modrate.
  IF (($len($3-) < 8) && ($len($3-) < 30)) { return }
  ; Start of processing text
  var %percent = $remove($countstr($3-,p).percent,%)
  IF (%percent > $cps.rvi($1,CAPS)) {
    set -u180 %rl.caps. [ $+ [ $address($2,2) ] ] $calc(%rl.caps. [ $+ [ $address($2,2) ] ] + 1)
    IF ((%rl.caps. [ $+ [ $address($2,2) ] ] == 1) && (%_cps.warn.caps == on)) {
      set %_cpsextra caps used $+($round(%percent,2),$chr(37),$chr(44)) allowed $+($cps.rvi($1,CAPS),$chr(37))
      warning $1 $2 caps
      return
    }
    IF ((%rl.caps. [ $+ [ $address($2,2) ] ] >= 1) && (%_cps.warn.caps == $null)) {
      set %_cpsextra caps used $+($round(%percent,2),$chr(37),$chr(44)) allowed $+($cps.rvi($1,CAPS),$chr(37))
      thrash $1 $2 caps
      return
    }
    IF ((%rl.caps. [ $+ [ $address($2,2) ] ] >= 2) && (%_cps.warn.caps == on)) {
      set %_cpsextra caps used $+($round(%percent,2),$chr(37),$chr(44)) allowed $+($cps.rvi($1,CAPS),$chr(37))
      thrash $1 $2 caps
      return
    }
  }
}


; Non English or Arabic Text detector [Noneng #Channel #nick TEXT]
; This alias detects if a nick is using too many non English chars and then punishes him or her accordingly
; The text or the last parameter is stripped of colors before it is sent to alias.
alias noneng {
  VAR %_text = $remove($3-,$chr(32))
  VAR %eng.c = 0
  VAR %eng.not = 0
  while (%eng.c < $len(%_text)) { 
    INC %eng.c 1 
    $iif($asc($mid(%_text,%eng.c,1)) > 127,inc %eng.not) 
  }
  VAR %percent = $round($calc(%eng.not / $len($strip(%_text)) * 100),2)
  ; if text has more that 75% non letters nick is kicked.
  IF (%percent > 75) {
    set -u180 %rl.noneng. [ $+ [ $address($2,2) ] ] $calc(%rl.noneng. [ $+ [ $address($2,2) ] ] + 1)
    IF ((%rl.noneng. [ $+ [ $address($2,2) ] ] == 1) && (%_cps.warn.noneng == on)) {
      set %_cpsextra Non English Letters Percentage $+(%percent,$chr(37),$chr(44))
      warning $1 $2 NONENG
      return
    }
    IF ((%rl.noneng. [ $+ [ $address($2,2) ] ] >= 1) && (%_cps.warn.noneng == $null)) {
      set %_cpsextra Non English Letters Percentage $+(%percent,$chr(37),$chr(44))
      thrash $1 $2 ATEXT
      return
    }
    IF ((%rl.noneng. [ $+ [ $address($2,2) ] ] >= 2) && (%_cps.warn.noneng == on)) {
      set %_cpsextra Non English Letters Percentage $+(%percent,$chr(37),$chr(44))
      thrash $1 $2 ATEXT
      return
    }
  }
}

; Non Letters Text detector [Nonlet #Channel #nick TEXT]
; This alias detects if a nick is using too many non letter chars and then punishes him or her accordingly

;The text or the last parameter is stripped of colors before it is sent to alias.
alias nonlet {
  var %text = $remove($3-,$chr(32))
  var %eng.c = 0
  var %eng.not = 0
  while (%eng.c < $len($strip(%text))) {
    inc %eng.c 1
    $iif($asc($mid(%text,%eng.c,1)) < 48,inc %eng.not)
  }
  VAR %percent = $round($calc(%eng.not / $len(%text) * 100),2)
  IF (%eng.not > 1) {
    IF (%percent >= $cps.rvi($1,NONLETTERS)) {
      set -u180 %rl.nol. [ $+ [ $address($2,2) ] ] $calc(%rl.nol. [ $+ [ $address($2,2) ] ] + 1)
      IF ((%rl.nol. [ $+ [ $address($2,2) ] ] == 1) && (%_cps.warn.non == on)) {
        set %_cpsextra Non Letters Percentage $+(%percent,$chr(37),$chr(44))
        warning $1 $2 NONLETTERS
        return      
      }
      IF ((%rl.nol. [ $+ [ $address($2,2) ] ] >= 1) && (%_cps.warn.non == $null)) {
        set %_cpsextra Non Letters Percentage $+(%percent,$chr(37),$chr(44))
        thrash $1 $2 NONLETTERS
        return      
      }
      IF ((%rl.nol. [ $+ [ $address($2,2) ] ] >= 2) && (%_cps.warn.non == on)) {
        set %_cpsextra Non Letters Percentage $+(%percent,$chr(37),$chr(44))
        thrash $1 $2 NONLETTERS
        return
      }
    }
  }
}

; Channel URL's spam detector and kicker [check.urls #Channel #nick TEXT]
; This alias detects if a nick has said a good url in the channel if not he is kicked
; This alias is only sent when a nick has said some url in a channel.
alias check.urls {
  var %good.urls = $numtok($cps.rvi($1,urlads),59)
  var %temp.var = 0
  while (%good.urls > 0) {
    IF (($gettok($cps.rvi($1,URLADS),%good.urls,59) iswm $3-) || ($+(*,$gettok($cps.rvi($1,URLADS),%good.urls,59),*) iswm $3-) || ($gettok($cps.rvi($1,URLADS),%good.urls,59) isin $3-)) {
      ;this var increases if a good url is found in text.
      inc %temp.var 1
    }
    dec %good.urls 1
  }
  ; IF the good urls count is zeros nick is punished/warned
  IF (%temp.var == 0) {
    set -u180 %rl.url. [ $+ [ $address($2,2) ] ] $calc(%rl.url. [ $+ [ $address($2,2) ] ] + 1)
    IF ((%rl.url. [ $+ [ $address($2,2) ] ] == 1) && (%_cps.warn.url == on)) {
      set %_cpsextra Bad URL Detected
      warning $1 $2 URLADS
      return
    }
    IF ((%rl.url. [ $+ [ $address($2,2) ] ] >= 1) && (%_cps.warn.url == $null)) {
      set %_cpsextra Bad URL Detected
      thrash $1 $2 URLADS

    }
    IF ((%rl.url. [ $+ [ $address($2,2) ] ] >= 2) && (%_cps.warn.url == on)) {
      set %_cpsextra Bad URL Detected
      thrash $1 $2 URLADS
      return
    }
  }
}

; Channel Mass Invite detector and kicker [check.chans #Channel #nick TEXT]
; This alias detects if a nick has said a good channel name in the channel if not he is kicked
; This alias is only sent when a nick has said some channel name in a channel. Note a channel name is a word starting with a -> #
alias check.chans {
  var %good.chans = $numtok($cps.rvi($1,CHANADS),59)
  var %temp.var = 0
  while (%good.chans > 0) { 
    IF (($gettok($cps.rvi($1,CHANADS),%good.chans,59) isin $3-) || ($+(*,$gettok($cps.rvi($1,CHANADS),%good.chans,59),*) iswm $3-) || ($gettok($cps.rvi($1,CHANADS),%good.chans,59) iswm $3-)) { inc %temp.var 1 } 
    dec %good.chans 1
  }
  IF (%temp.var == 0) {
    set -u180 %rl.chanads. [ $+ [ $address($2,2) ] ] $calc(%rl.chanads. [ $+ [ $address($2,2) ] ] + 1)
    IF ((%rl.chanads. [ $+ [ $address($2,2) ] ] == 1) && (%_cps.warn.chanads == on)) {
      set %_cpsextra Bad Channel-Name Detected
      warning $1 $2 chanads
      return
    }
    IF ((%rl.chanads. [ $+ [ $address($2,2) ] ] >= 1) && (%_cps.warn.chanads == $null)) {
      set %_cpsextra Bad Channel-Name Detected
      thrash $1 $2 chanads
      return
    }
    IF ((%rl.chanads. [ $+ [ $address($2,2) ] ] >= 2) && (%_cps.warn.chanads == on)) {
      set %_cpsextra Bad Channel-Name Detected
      thrash $1 $2 chanads
      return
    }
  }
}

; Idle nick checker and kicker [check.chans #Channel #nick TEXT]
; This alias detects if a nick has been idling in a channel if so he/she is kicked.
; This alias is a part of internal channel independent timer which is invoked if this kick is on for that channel.
alias idlekick {
  IF ($me isop $1) {
    var %total.nicks = $nick($1,0)
    while (%total.nicks > 0) {
      ;$nick($1,$nick($1,%total.nicks)).idle = idle time of a nick in a channel
      IF ($nick($1,%total.nicks).idle >= $calc($cps.rvi($1,idle) * 60)) {
        set %_cpsextra Idle Time $duration($nick($1,%total.nicks).idle) $+ , Maximum Allowed $duration($calc($cps.rvi($1,idle) * 60))
        IF ($nick($1,%total.nicks) != $me) { thrash $1 $nick($1,%total.nicks) IDLE }
      }
      dec %total.nicks 1
    }
  }
}

; Internal Filter Kicker for mass join flood [fk #Channel nick|address]
; This alias detects if a nick has been idling in a channel if so he/she is kicked.
; This alias is a part of internal channel independent timer which is invoked if this kick is on for that channel.
alias fk {
  var %fk = $ialchan($2,$1,0)
  while (%fk > 0) {
    set %_cpsextra $gettok($3-,2,32) Nicks Joinned in $replace($duration($gettok($3-,3,32)),0,1)
    thrash $1 $ialchan($2,$1,%fk).nick JPFLOOD
    dec %fk 1
  }
}

; Un moder [undomirc #Channel]
; This alias is called after a flood and removes the channel modes gradually
; You may edit the time after which modes are unseted
alias undomirc {
  IF ($me isop $1) {
    .timerUNDO1 1 5 .raw -q MODE $1 -i
    .timerUNDO2 1 30 .raw -q MODE $1 -mk $chan($1).key
    .timerUNDO3 1 65 .raw -q MODE $1 -c
  }
}

;Timestamp for CPS echo [$_time]
;Timestamps echos if you have enabled timestamp
alias _time {
  IF (%_cps.time == on) { return $timestamp }
}

; Echo display manager [$_time]
; This identifier return -s if you have chosen echoes to be shown in status window or returns -a for active window
;-a and -s are case sensitive
alias _place {
  IF (%_cps.echo == status) { return -s }
  IF (%_cps.echo == active) { return -a }
  IF (%_cps.echo == window) { return window }
}

alias echo { 
  IF ($2 == window) {
    IF (!$window(@cps)) {
      window -n @cps
      !echo $1 @cps $3-
    }
    ELSE { !echo $1 @cps $3- }
  }
  ELSE { !echo $1- }
}
; Is Protected? [$isprot($channel,$nick)]
; Identifier used to find out if the nick is protected in the channel
; Requires parameter one to be channel and second to be the nick
alias isprot {
  var %protect.list = $cps.rvi($1,MYNICKS)
  IF ($istok(%protect.list,$2,59) == $true) { return $true } 
  ELSE { return $false }
}

; Is Service? [$isprot($nick)]
; Identifier used to find out if the nick is a services nick
; Requires parameter one to be the nick
alias isservice {
  IF (($1 == NickServ) || ($1 == OperServ) || ($1 == ChanServ) || ($1 == MemoServ) || ($1 == X) || ($1 == Y) || ($1 == ChanOp) || ($1 == NickOp) || ($1 == Q) || (*.* iswm $1) || ($1 == Z) || ($1 == -psyBNC)) { return $true } 
  ELSE { return $false }
}

; CPS Warning sender [Warning #channel Nick Type]
; Sends a warning via notice to the nick that broke a rule in a channel
; It doesn't warn protected, services nicks
alias Warning {
  IF (($isprot($1,$2) == $false) && ($isservice($2) != $true)) {
    IF ($2 isvo $1) { IF ($cps.rvi($1,KICKVOS) != on) { return } }
    IF ($2 isop $1) { IF ($cps.rvi($1,KICKOPS) != on) { return } }
    var %cw = %_cpsextra
    var %c = $1
    var %n = $2
    var %r = $3
    unset %_cpsextra
    IF (%r == swear) {
      .notice %n %_cps.swear.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Swearing!
      return
    }
    ELSEIF (%r == repeat) {
      .notice %n %_cps.repeat.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Repeating!
      return
    }
    ELSEIF (%r == txtflood) {
      .notice %n %_cps.text.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Text Flooding!
      return
    }
    ELSEIF (%r == longtxt) {
      .notice %n %_cps.long.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Long text!
      return
    }
    ELSEIF (%r == punctuation) {
      .notice %n %_cps.punctuation.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Punctuation!
      return
    }
    ELSEIF (%r == caps) {
      .notice %n %_cps.caps.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Excessive caps!
      return
    }
    ELSEIF (%r == colors) {
      .notice %n %_cps.colors.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Colours!
      return
    }
    ELSEIF (%r == urlads) {
      .notice %n %_cps.urlads.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for URL advertisment!
      return
    }
    ELSEIF (%r == chanads) {
      .notice %n %_cps.chanads.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Channel Advertisment!
      return
    }
    ELSEIF (%r == nonletters) {
      .notice %n %_cps.non.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for NON Letters!
      return
    }
    ELSEIF (%r == sounds) {
      .notice %n %_cps.sounds.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Sounds!
      return
    }
    ELSEIF (%r == slaps) {
      .notice %n %_cps.slaps.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Slaps!
      return
    }
    ELSEIF (%r == euser) {
      .notice %n %_cps.user.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for User Exploitation!
      return
    }
    ELSEIF (%r == cnote) {
      .notice %n %_cps.cnote.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Channel Notices!
      return
    }
    ELSEIF (%r == away) {
      .notice %n %_cps.away.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Away scripts!
      return
    }
    ELSEIF (%r == clones) {
      .notice %n %_cps.clone.warn  Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Cloning!
      return
    }
    ELSEIF (%r == noneng) {
      .notice %n %_cps.noneng.warn Note:- %cw
      echo $color(info2) $_place $_time *** 4(CPS) %n was warned in %c for Non English!
      return
    }
    ELSE { echo $color(info) $_place $_time invalid paramets in Warning! prameters-used10 $+($chr(40),$1-,$chr(41)) }
  }
}

; CPS Drone-Bot Notice sender [cps.load HASH-Table-Name Size]
; If a nick is kicked for suspected dronebot he she is sent a key with a notice via this alias to get un banned.
; This supports both manual and auto kick
alias cps.drone {
  ; We make a temporary hash table called drone, if it already doesn't exists
  IF ($hget(drone) == $null) { .hmake drone 10 }
  VAR %key = $+($2,$rand(1,9999))
  .hadd drone %key $3
  .notice $2 IF you are not a spam bot and this kick was wrong type >> /notice $me !unbanme $1 %key  << and join back the channel ( $+ $1 $+ ) in 20 seconds, you will not be kicked next time. NOTE: Type this command once in any window of mIRC!
}

; CPS Hash Writer [cps.rvs HASH-Table Item Data]
; Custom Command to write data in hash tables
; The hash table must exist
alias cps.rvs { .hadd -m $1 $2 $3- }

; CPS Hash Remover [cps.rvd HASH-Table Item]


; Custom Command to del data of an item in hash tables
; The hash table must exist
alias cps.rvd { .hdel $1 $2- }

; CPS Hash Reviler [$cps.rvi(HASH-Table,Item)]
; Returns data of the particular Item
; The hash table must exist
alias cps.rvi { return $hget($1,$2) }

; CPS Hash Saver [cps.save HASH-Table]
; Saves the hash table to CPS directory with the extension .hsh
; The hash table must exist
alias cps.save { .hsave -o $1 $+($scriptdir,$1,.hsh) }

; CPS Hash Maker [cps.make HASH-Table Size]
; Custom Command to make a hash table.
; Both the parameters are required
alias cps.make { .hmake $upper($1) $2 }

; CPS Hash Loader cum Maker [cps.load HASH-Table-Name Size]
; First makes the hash table then loads it up from .hsh file in script directory
; The hash table file must exist.
alias cps.load {
  $cps.make($1,$2)
  .hload $1 $+($scriptdir,$1,.hsh)
}

; CPS Hash File Remover [cps.rem HASH-Table-Name]
; Removes the already existing .hsh file of a hash table
; The hash table file must exist.
alias cps.rem { .remove $+($scriptdir,$1-,.hsh) }

; CPS Hash Free [cps.free HASH-Table-Name]
; Frees a hash table from mIRC's memory
; The hash table must be loaded.
alias cps.free { .hfree $1- }

; CPS Hash Token Setter [cps.set HASH-Table-Name ITEM Token-Number Value]
; The token here is 44 or a comma. This alias is used generally to edit the NX value of a the hash table
; The hash table file must exist.
alias cps.set {
  var %read.token = $cps.rvi($1,$2)
  cps.rvs $1 $2 $puttok(%read.token,$4,$3,44)
}

; CPS Hash Token Reader [$cps.rval(HASH-Table-Name,Item,Token-Number)]
; Custom identifier used to read the token values inside a token char of a hash table
; The hash table file must exist.
alias cps.rval { return $gettok($cps.rvi($1,$2),$3,44) }

; Kick Alias for nick list popup menu [_mkick Nick Reason Channel]
; Reason is one of the predefined ones.
; Confirms if you want to kick ops
alias _mkick {
  IF ($1 !isop $3) {
    unset %_cpsextra
    set %kicktype [Manual]
    IF ($2 == ad) { kickc $3 $1 Advertising is against the policies of $3 }
    ELSEIF ($2 == invi) { kickc $3 $1 Inviting is against the policies of $3 }
    ELSEIF ($2 == swear) { kickc $3 $1 Use of abusive or bad words is not allowed on $3 }
    ELSEIF ($2 == annoy) { kickc $3 $1 Do not annoy people here! }
    ELSEIF ($2 == Flood) { kickc $3 $1 Flooding is not tolerated in $3 }
    ELSEIF ($2 == autog) { kickc $3 $1 Sending auto-greets is not allowed in $3 }
    ELSEIF ($2 == nick) { kickc $3 $1 Get a nicer nick like mine type "/nick newnick" to change nick }
    ELSEIF ($2 == ident) { kickc $3 $1 Change your identd its not allowed on $3 }
    ELSEIF ($2 == hass) { kickc $3 $1 Operators hassling is an absolute no no }
    ELSEIF ($2 == rep) { kickc $3 $1 Repeating is not allowed }
    ELSEIF ($2 == caps) { kickc $3 $1 Use of excess capital letters is not allowed }
    ELSEIF ($2 == sex) { kickc $3 $1 This is not a sex channel }
    ELSEIF ($2 == fmli) { kickc $3 $1 $3 is a family oriented channel, so behave. }
    ELSEIF ($2 == english) { kickc $3 $1 Speak English in $3 }
    ELSEIF ($2 == opbeg) { kickc $3 $1 Op or voice begging is not allowed in $3 }
    ELSEIF ($2 == script) { kickc $3 $1 Stop using a script that is spamming in one way or other. }
  }
  ELSE {
    IF ($input(Are you absolutely sure you want to kick??,296,immune Warning) != $yes) { return }
    ELSE {
      unset %_cpsextra
      set %kicktype [Manual]
      IF ($2 == ad) { kickc $3 $1 Advertising is against the policies of $3 }
      ELSEIF ($2 == invi) { kickc $3 $1 Inviting is against the policies of $3 }
      ELSEIF ($2 == swear) { kickc $3 $1 Use of abusive or bad words is not allowed on $3 }
      ELSEIF ($2 == annoy) { kickc $3 $1 Do not annoy people here! }
      ELSEIF ($2 == Flood) { kickc $3 $1 Flooding is not tolerated in $3 }
      ELSEIF ($2 == autog) { kickc $3 $1 Sending auto-greets is not allowed in $3 }
      ELSEIF ($2 == nick) { kickc $3 $1 Get a nicer nick like mine type "/nick newnick" to change nick }
      ELSEIF ($2 == ident) { kickc $3 $1 Change your identd its not allowed on $3 }
      ELSEIF ($2 == hass) { kickc $3 $1 Operators hassling is an absolute no no }
      ELSEIF ($2 == rep) { kickc $3 $1 Repeating is not allowed }
      ELSEIF ($2 == caps) { kickc $3 $1 Use of excess capital letters is not allowed }
      ELSEIF ($2 == sex) { kickc $3 $1 This is not a sex channel }
      ELSEIF ($2 == fmli) { kickc $3 $1 $3 is a family oriented channel, so behave. }
      ELSEIF ($2 == english) { kickc $3 $1 Speak English in $3 }
      ELSEIF ($2 == opbeg) { kickc $3 $1 Op or voice begging is not allowed in $3 }
      ELSEIF ($2 == script) { kickc $3 $1 Stop using a script that is spamming in one way or other. }
    }
  }
}

; Edit or add a channel url [Changeurl #channel]
; The channel must be in the protected list.
alias changeurl {
  IF (($1 != $null) && ($istok($cps.rvi(DEFAULT,CONTROLCHAN),$1,44) == $true)) {
    var %channel.url = $input(Enter the name of related help channel or website-url of $+(",$1,") which you want to include in your kick message: e.g. http://www.mIRCscripts.org for channel #mIRCscripts.org. This input is $+(optional,$chr(44)) leave it blank IF you want to!,1,CPS Requesting Input)
    IF (%channel.url != $null) { 
      cps.rvs $1 channelurl %channel.url
      echo $color(info2) $_place $_time *** 4(CPS) The url for channel10 $1 set to10 %channel.url $+ !
    }
    ELSE { 
      cps.rvs $1 channelurl %channel.url
      echo $color(info2) $_place $_time *** 4(CPS) The URL for $1 has been wiped.
    }
  }
  ELSE { echo $color(info2) $_place $_time *** 4(CPS)10 $1 was not found in protected channel list! }
  IF ($dialog(cps) == cps) { cps }
}

; List possible bad nicks [cps.bad]
; Must be typed in a channel and user must be op
alias cps.bad {
  IF (($server != $null) && ($me isop $active) && ($left($active,1) == $chr(35))) {
    echo $color(info2) $_place $_time *** 4(CPS) Listing bad nicks on $active
    var %a = $nick($chan,0)
    while (%a > 0) {
      IF (peni isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (pros isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (porn isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (sex isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (puss isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (cock isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (gay isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (fuc isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (suc isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (boob isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (slut isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (dic isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (ass isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (shit isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (butt isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (lick isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (prick isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      IF (suck isin $nick(#,%a)) { echo $color(info2) -st $nick(#,%a) is a possible bad nick! matches -->10 $ifmatch }
      dec %a 1
    }
    echo $color(info2) $_place $_time *** Ended listing bad nicks in $active check status window for possible results!
  }
}

; Sets channel limit [cps.limit #channel]
; The channel must be in the protected list.
alias cps.limit {
  IF ($server != $null) {
    IF ($me isop $1) {
      IF ($chan($1).limit != $calc($nick($1,0) + $cps.rvi($1,USERLIMIT))) { .raw -q mode $1 +l $calc($nick($1,0) + $cps.rvi($1,USERLIMIT)) }
    }
  }
}

; Timer invoke alias [_ulimit #channel]
; This alias is called by various events on [op|join] or when you get op 
alias _ulimit {
  IF ($cps.rvi($2,LIMITER) == ON) {
    IF ($server != $null) {
      IF (($1 == ON) && ($cps.rvi($2,userlimit.time) != $null)) {
        .timerLIMIT [ $+ [ $2 ] ] 0 $calc($cps.rvi($2,USERLIMIT.TIME) * 60) cps.limit $2
        cps.limit $2
      }
    }
  }
  IF ($1 == OFF) { .timerLIMIT [ $+ [ $2 ] ] OFF }
}

; Sets channel modes [moder #channel]
; The channel must be in the protected list.
alias moder { 
  unset %mody 
  IF (m isin $chan($1).mode) { set %mody m } 
  IF (i isin $chan($1).mode) { set %mody $addtok(%mody,i,59) }
  IF (c isin $chan($1).mode) { set %mody $addtok(%mody,c,59) }
  IF (%mody != $null) { .MODE $1 $+(-,$remove(%modi,;)) } 
  IF (k isin $chan($1).mode) { .MODE $1 -k $chan($1).key } 
  unset %mody
}

; Whoon is used when u type a /[whois|who|whowas|w] nick

; This enables raws and displays a whois
alias whoon { .disable #halts }

; Whooff is used after u have typed / [whois|who|whowas|w] nick
; This again disables raws and displays a whois
alias whooff { .enable #halts }

; Ban detector Toggle [Bdet ON|OFF]
; Toggles ban detector on or off
alias bdet { 
  IF ($1 == ON) {
    .enable #bandet
    echo $color(info2) $_place $_time *** 4(CPS) Ban-Detector is now Enabled.
  }
  ELSEIF ($1 == OFF) {
    .disable #bandet
    echo $color(info2) $_place $_time *** 4(CPS) Ban-Detector is now Disabled.
  }
  ELSE { echo $color(info2) $_place $_time *** 4(CPS) Un Known Parameters use /bdet on or /bdet off }
}

; Owner
alias owner {
  IF ($1 == %loggednick) { return $true }
  ELSE { return $false }
}
; Protect channel [pc]
; An emergency alias to shut down a channel for 20 seconds
alias pc {
  .mode $active +mick $rand(1,1000)
  .timeruu 1 20 .mode $active -mick $chan($active).key
}

; Internal alias used for bot section
; Replaces incoming text to known type
alias ktype {
  var %i = $1-
  var %i = $replace(%i,URL-ADS,urlads,CHAN-ADS,chanads,BAD-NICK,nick,BAD-IDENT,ident,BAD-SCRIPT,script,BAD-CHANNEL,channel,BLACKLISTED,blnic,REPEATING,repeat,TEXT-FLOOD,txtflood,MP3-PLAY,sound)
  var %i = $replace(%i,TROUT-SLAP,slap,CHANNEL-NOTICE,cnote,JOIN-FLOOD,jpflood,QUIT-FLOOD,qflood,AWAY-SCRIPT,away,CTCTP-FLOOD,ctcpf,REV-DOORS,door,LONG-TEXT,longtxt,CAPS-LOCK,caps,NON-LETTERS,nonletters,IDLE-NICK,idle)
  var %i = $replace(%i,ARABIC-TEXT,atext,EXPLOIT-USER,euser,DRONE-BOT,drone,GUEST-NICK,guest,ON-JOIN-CTCP,ojctcp,ON-JOIN-NOTICE,ojnote,ON-JOIN-MESSAGE,ojmsg,KLINED,kline,EXCESS-FLOOD,excess,SPAM-QUIT,squit)
  return %i
}

;activates the help was asked wihout any particular parameter
alias _help {
  IF ($2 == all) { .play $1 $scriptdirbf.func 2000 }
}

; Unwhois [unwhois]
; Stops the whois of ppl
alias unwhois {
  IF ($timer(WHOISD) != $null) { .timerWHOISD off }
}
alias sb_rehash {
  sb_close
  .timerSBREHASH 1 5 sb_open
}

; Based on the socket bot tutorial by - myndzi
; Provided by http://www.mIRCscripts.org
; Socket bot routine alias
; This alias creates the bot connection.
alias sb_open {
  ; If it already exists, don't go any further
  IF ($sock(sb)) { return }
  ; If the debug window is open, change the title bar to reflect what we're doing
  IF ($window(@sb)) { titlebar @sb - Connecting }
  ; Identd request
  ; sock.identd $sb_identd
  ; Enable the group (at the bottom) that will grab our nick and trigger the CONNECT event
  .enable #sb_connecting
  ; Actually open the socket
  sockopen sb $sb_server $sb_port
}


; This alias closes the socket and cleans everything up (calls sb_cleanup)
alias sb_close {
  sb_out QUIT Bye!
  sb_cleanup
}

; This alias sends a QUIT message; do not close socket (wait for server to do so)
alias sb_quit { sb_out QUIT $iif($0,: $+ $1-) }

; This alias sends data to the server
alias sb_out {
  ; If the socket is not open, go no further
  IF ($sock(sb) == $null) { return }
  ; If the debug window is open, show it what's happening
  IF ($window(@sb)) { echo $color(notice) -ti2 @sb >> $1- }
  ; Send the data
  sockwrite -n sb $1-
}

; This alias opens the debug window
alias sb_debug {
  ; Create window with edit box
  window -e @sb
  ; If we're connected, set title bar to show which nick
  IF ($_online) { titlebar @sb - Nick: $_me }
  ; Otherwise set it to "Disconnected"
  ELSE { titlebar @sb - Disconnected }
}

; This alias cleans up everything when the socket closes/is closed
alias sb_cleanup {
  ; If the debug window is open, set the title bar to reflect that we are no longer connected
  IF ($window(@sb)) { titlebar @sb - Disconnected }
  ; Close the socket
  sockclose sb
  ; See near the end of this document for the #sb_connecting group info
  .disable #sb_connecting
  ; Unset %sb_me (socket bot's nick) after this alias concludes
  ; Send out a signal that we have become disconnected
  ; See below for more info, note the lack of an underscore
  .signal -n sbeDISCONNECT
  .timerSB* OFF
  unset %sb_me
}


; These four aliases return information used on connect to the server -- change at will
; Socketbot identify
alias sb_identify {
  IF ($1 == MSG) { sb_out PRIVMSG $2- }
  ELSE { sb_out $1- }
}

; Socketbot nick
alias sb_nick { return $cps.rvi(default,sbnick) }

; Socketbot alterative nick
alias sb_anick { return $cps.rvi(default,sbanick) }

; Socketbot identd
alias sb_identd { return $cps.rvi(default,sbidentd) }

; Socketbot name
alias sb_name { return $cps.rvi(default,sbname) }

; Socketbot server
alias sb_server { return $cps.rvi(default,sbserver) }

; Socketbot name
alias sb_port { return $cps.rvi(default,sbport) }

; Socketbot part message
alias sb_partmsg { return $cps.rvi(default,sbpartmsg) }

; Socketbot password
alias sb_pass { return $cps.rvi(default,sbpass) }

; Used identifiers
alias _getnick { return $gettok($_strip:($1),1,33) }
alias _getuser { return $gettok($gettok($1,2,33),1,64) }
alias _gethost { return $gettok($1,2,64) }

; The next identifier strips a proceeding ":" character if it is there:
alias _strip: { return $iif(:* iswm $1,$right($1,-1),$1) }

; This identifier returns the bot's nick or sets it to a new nick.
; I do not recommend calling this one yourself as a command;
; It should only be called from the sbe_NICK signal included.
; This identifier also updates the @sb window if it is open.
alias _me {
  IF ($isid) { 
    return %sb_me
    set %sb_me $$1
  }
  if ($window(@sb)) { titlebar @sb - Nick: %sb_me }
}

; This identifier returns $true if the socket is connected, $false otherwise.
alias _online { return $iif($sock(sb),$true,$false) }

alias sb_hop {
  sb_out PART $1 : $+ $sb_partmsg
  .timerSB_JOIN $+ $1 1 2 sb_out JOIN $1
}

alias sb_connected {
  _me $1
  IF ($window(@sb)) { titlebar @sb - Nick: $_me }
  .disable #sb_connecting
  .signal -n sbeCONNECT
}

;----------------------------------------
; Section F
;----------------------------------------
; Desc: Contains various events used for


;       cps's genral setup and startup.
;----------------------------------------


; Event is called when this file is unloaded
; unsets all the cps variables
ON *:UNLOAD: {
  linesep
  unset %_cps*
  unset %controlchan
  unset %cps.protchan
  unset %bantime
  unset %spam.words
  unset %_mspam*
  echo $color(info2) $_place $_time ***4 (CPS)
  linesep
  echo $color(info2) $_place $_time *** 4(CPS) Un-installation successful...
  echo $color(info2) $_place $_time *** 4(CPS) to Reload type -> 12/load -rs $+(",$findfile($mIRCdir,*firststep*,1),") $+ 
  linesep
}

; This event is called every time mIRC starts
ON *:START: {
  ; Switching on flood protection
  .Flood +c on
  ; Enabling all cps groups
  .enable #cpsgroup*
  .enable #cpsfloodd*
  .timerGroupCHECK -i 0 20 .enable #cps*
  ; These 3 alias load up hash tables
  _loadhash
  _loading
  ;setting the cpslogo in default hash table after load
  cps.rvs default VERSION $remove(%_cpslogo,CPS by Amit) version 7.0
  IF ($script($scriptdirfirststep.mrc) != $null) { .unload -rs $scriptdirfirststep.mrc }
  ;the below events are used when u first time u start mirc after loading cps
  IF (%cpsfirst != $null) { inc %cpsfirst 1 }
  IF (%cpsfirst == 3) { 
    ;opens about dialog
    .timer9 1 4 _about 
    unset %cpsfirst
    echo $color(info2) $_place $_time *** 4(CPS) Setup is done check 'MenuBar' or Right click in Channel or Status Window!
    ; echo $color(info2) $_place $_time *** 4(CPS) NOTE: The password you entered in setup is not for your anti-spam bot!!! Read FAQ.txt carefully to learn more about it!!
    echo $color(info2) $_place $_time *** 4(CPS) Thank you for choosing CPS =)
    echo $color(info2) $_place $_time *** 4(CPS) This addon has been released under the GNU/GPL, read 'copying.txt' for more info.
    .run $scriptdirfaq.txt
    .run $scriptdirReadMe.txt
  }
}

; This event is called before mirc closes
; It saves all the hash tables and clears useless variables
ON *:EXIT:{
  IF (%setup.run == YES) {
    unset %setup.run
    .run mirc.exe $+(",$scriptdirmirc.ini,")
  }
  var %a = $hget(0)
  while (%a > 0) {
    IF (($hget(%a) == default) || ($hget(%a) == cpsk) || ($left($hget(%a),1) == $chr(35))) { cps.save $upper($hget(%a)) }
    DEC %a 1
  }
  unset %rl*
  unset %fld*
  unset %txt*
  unset %undo.*
  unset %loggednick
}

;----------------------------------------
; Section G
;----------------------------------------
; Desc: Contains support alias for all
;       events used in this script.
;----------------------------------------


; Unloader [_unload ALL]
; Unload all the hash tables and the script files
alias _unload {
  IF ($1 == all) {
    _unloadhsh
    if ($script(cps.mrc)) { .unload -rs $ifmatch }
    if ($script(cps1.mrc)) { .unload -rs $ifmatch }
    if ($script(cpsr.mrc)) { .unload -rs $ifmatch }
    if ($script(cpsr1.mrc)) { .unload -rs $ifmatch }
    if ($script(cpsr2.mrc)) { .unload -rs $ifmatch }
    IF ($script(cpsalias.mrc)) { .unload -rs $ifmatch }
  }
}

; Unloadhsh [_unloadhsh]
; Unload all the hash tables.
alias _unloadhsh {
  var %a = $hget(0)
  while (%a > 0) { 
    IF (($hget(%a) == DEFAULT) || ($hget(%a) == CPSK) || ($left($hget(%a),1) == $chr(35))) {
      .hfree $hget(%a)
    }
    dec %a 1
  }
}

; _loadhsh [_loadhsh]
; Finds all the .hsh files from the script dir and sets there name in a variable
alias _loadhash {
  unset %_cps.hsh
  var %a = $findfile($scriptdir,*.hsh,0)
  while (%a > 0) {
    set %_cps.hsh $addtok(%_cps.hsh,$upper($remove($nopath($findfile($scriptdir,*.hsh,%a)),.hsh)),44)
    dec %a 1
  }
}

; _loading [_loading]
; Loads all the hash tables from the variable created in the alias  _loadhsh
alias _loading {
  var %a = $numtok(%_cps.hsh,44)
  while (%a > 0) {
    IF ($hget($gettok(%_cps.hsh,%a,44)) == $null) { cps.load $upper($gettok(%_cps.hsh,%a,44)) 20 }
    dec %a 1
  }
}
==================================================================================
Author  : Fearphage
Function: /cps.hlist displays the hashtables and its size being used
==================================================================================

alias cps.hlist { 
  VAR %hlist = 1
  linesep -a
  echo -a * $iif(!$hget(%hlist),No h,H) $+ ash tables in use $iif(!$ifmatch,$+($chr(40),$hget(0),$chr(41)))
  WHILE ($hget(%hlist)) {
    echo $colour(info2) -a $nbsp $hget(%hlist) ( $+ $hget(%hlist).size $+ )
    INC %hlist
  }
  linesep -a
}
alias nbsp { return $str($chr(160),$iif($1 isnum,$1,3)) }
;=========================================================================================
;Name:$countstr
;Author:zonIRC
;Email:zonirc@email.com
;Description:Count the total/percentage of uppercase/lowercase/symbol/bold/underline/reverse/colour text.
;Syntax:$countstr(<text>,<switch>)[.properties]
;Switch:Only one can be specified at a time and its a case sensitivity.
;       l=lowercase,p=uppercase,s=symbol,b=bold,c=colour,u=underline and r=reverse.
;Properties:.percent - return percentage which is will be rounded to 2 decimal digit.
;Info: Here is the calculation method to get a percentage
;      s = total_symbol x 100 / length_of_text_without_spaces
;      p and l = total_uppercase/lowercase x 100 / total_letters_in_text
;      b = total_bold_text x 100 / length_of_text_without_control_codes_and_spaces
;      c,r and u = total_colour/underline/reverse_text x 100 / length_of_text_w/o_ctrl_code
;=========================================================================================

alias countstr {
  if ($isid) {
    ;allow only specified switch
    if ($istokcs(p l s b c r u,$2,32)) {
      ;set %strem as a teks in $1 which is will be stripped except for the specified switch
      ;only apply to bcru), and if switch being specified is b or s then spaces will be removed
      ;from text.
      var %tmp, %total, %strem = $strip($iif($2 isletter bs,$remove($1,$chr(32)),$1),$remove(bcru,$2))
      if ($2 isletter pls) {
        %total = $regex(%strem,/[ $+ $replace($2,s,^A-Za-z0-9,p,A-Z,l,a-z) $+ ]/g)
        %tmp = $iif($2 == s,$len(%strem),$regex(%strem,/[a-zA-Z]/g))
      }
      else { var %total = %strem | while ($regsub(%total,[^]*?|[^]*?|[^]*?|(1[0-5]|[0-9])[^]*?,$iif($2 == c,),%total)) !
        %tmp = $len($strip(%strem))
        %total = $calc(%tmp - $len($strip(%total)))

      }
      return $iif($prop,$round($calc(%total * 100 / %tmp),2) $+ $chr(37),%total)
    }
  }
  echo -ast * $iif($isid,$ $+ countstr: $iif(!$1 || !$2,Missing $iif($2,Text,Switch),Invalid $iif(!$istok(l p s b c r u,$2,32),Switch - $2,Properties - $prop)),/countstr:Unknown Command)
}

;=======================================;
; :::          End Of File          ::: ;
;=======================================;
